<?php
defined('_JEXEC') or die('Restricted access');

class plgHikashoppaymentComnpay extends hikashopPaymentPlugin
{
	var $version = '1.1';
	var $accepted_currencies = array( "EUR", "USD" ); 
	var $multiple = true; // Multiple plugin configurations. It should usually be set to true
	var $name = 'comnpay'; //Payment plugin name (the name of the PHP file)
	//This array contains the specific configuration needed (Back end > payment plugin edition)
	var $pluginConfig = array(
		'tpe' => array('TPE Number', 'input','DEMO'),
		'key' => array('Secret Key', 'input','DEMO'),
		'url_homologation' => array('URL Homologation','input','https://secure-homologation.comnpay.com'),
		'url_production'=>array('URL Production','input','https://secure.comnpay.com'),
		'debug' => array('DEBUG', 'boolean','0'),
		'plateforme' => array('Plateforme', 'list',array(
			'homologation'=>'Homologation',
			'production'=>'Production')
		),
		'cancel_url' => array('CANCEL_URL', 'input'),
		'return_url' => array('RETURN_URL', 'input'),
        'pnf' => array('Autoriser le Paiement en 3 fois', 'boolean','0'),
		'type_transaction' => array('Transaction type', 'list',array(
			'D'=>'D&eacute;bit imm&eacute;diat'
			//'PA'=>'Pr&eacute; Autorisation'
			)
		),
		'verified_status' => array('VERIFIED_STATUS', 'orderstatus', 'confirmed'),
		'invalid_status' => array('INVALID_STATUS', 'orderstatus', 'cancelled'),
	);

	/*To set the specific configuration (back end) default values (see $pluginConfig array)*/
	function getPaymentDefaultValues(&$element) {
		$element->payment_name = 'comNpay';
		$element->payment_description = 'Pay by credit card through our secure gateway comNpay';
		$element->payment_images = 'comnpay_debit';
		$element->payment_params->tpe = 'DEMO';
		$element->payment_params->key = 'DEMO';
		$element->payment_params->url_homologation = 'https://secure-homologation.comnpay.com';
		$element->payment_params->url_production = 'https://secure.comnpay.com';
		$element->payment_params->invalid_status = 'cancelled';
		$element->payment_params->type_transaction = 'D';
		$element->payment_params->pending_status = 'created';
		$element->payment_params->verified_status = 'confirmed';
	}

	/*This function is called at the beginning of the checkout(check the empty fields in the comnpay config)*/
	function onBeforeOrderCreate(&$order,&$do){
		if(parent::onBeforeOrderCreate($order, $do) === true)
			return true;

		if(empty($this->payment_params->tpe) || empty($this->payment_params->key)) {
			$this->app->enqueueMessage('You have to configure comNpay settings');
			$do = false;
		}

	}

    /* This function display a checkbox to pay in 3 times */
    function needCC(&$method)
    {
        //on auto submit le formulaire lors du choix du type de paiement
        $onclick = '';
        $config = hikashop_config();
        if($config->get('auto_submit_methods',1)){
            $onclick = ' onclick="this.form.action=this.form.action+\'#hikashop_payment_methods\';this.form.submit(); return false;"';
        }
        if(@$method->payment_params->pnf == true) {
            //valeur sélectionné lors du submit du formulaire
            if(isset($_REQUEST["hikashop_comnpay_pnf"]))
                $default = $_REQUEST["hikashop_comnpay_pnf"];
            else
                $default = '';

            $arr = array(
                JHTML::_('select.option', 'd', JText::_("Payer en une seule fois")),
                JHTML::_('select.option', 'p3f', JText::_("Payer en 3 fois sans frais "))
            );
            $method->custom_html = JHTML::_('select.radiolist', $arr, "hikashop_comnpay_pnf", $onclick,'value', 'text', $default, false);
            return true;
        }
    }

	//*This function is called at the end of the checkout. That's the function which should display your payment gateway redirection form with the data from HikaShop */
	function onAfterOrderConfirm(&$order,&$methods,$method_id) {
		parent::onAfterOrderConfirm($order,$methods,$method_id);
		$config = JFactory::getConfig();
		if(!empty($this->payment_params->cancel_url))
			$nok_url = $this->payment_params->cancel_url;
		else	
			$nok_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id='.$order->order_id.$this->url_itemid;
		if(!empty($this->payment_params->return_url))
			$ok_url = $this->payment_params->return_url;
		else
			$ok_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id.$this->url_itemid;
		
		$ipn_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment='.$this->name.'&tmpl=component';
				
		$this->vars = array(
			'montant'=>round($order->cart->full_total->prices[0]->price_value_with_tax,2),
			'idTPE'=>$this->payment_params->tpe,
			'idTransaction'=>time().'-'.$order->order_id,
			'devise'=>$this->currency->currency_code,
			'lang'=>$this->locale,
			'nom_produit'=>$config->get( 'sitename' ),
			'source'=>$_SERVER['SERVER_NAME'],
			'urlRetourOK'=>$ok_url,
			'urlRetourNOK'=>$nok_url,
			'typeTr'=>$this->payment_params->type_transaction,
            'data' => $this->payment_params->type_transaction,
			'urlIPN'=>$ipn_url,
			'extension'=>'hikashop-'.$this->version
		);
        //si le p3f est activé sur l'admin
        if(isset($_REQUEST["hikashop_comnpay_pnf"])) {
            $this->vars["typeTr"] = $_REQUEST["hikashop_comnpay_pnf"];
            $this->vars["data"] = $_REQUEST["hikashop_comnpay_pnf"];
            if($_REQUEST["hikashop_comnpay_pnf"] == "p3f") {
                $this->vars["user_nom"] = $order->cart->billing_address->address_lastname;
                $this->vars["user_prenom"] = $order->cart->billing_address->address_firstname;
                $this->vars["user_email"] = $order->cart->customer->email;
                $this->vars["user_telephone"] = $order->cart->billing_address->address_telephone;
                $this->vars["user_adresse"] = $order->cart->billing_address->address_street;
                $this->vars["user_codePostal"] = $order->cart->billing_address->address_post_code;
                $this->vars["user_ville"] = $order->cart->billing_address->address_city;
                $this->vars["user_pays"] = $order->cart->billing_address->address_country->zone_name;
            }
        }
        $this->vars["key"] = $this->payment_params->key;

		$comnpayWithKey = base64_encode(implode("|", $this->vars));
		unset($this->vars['key']);
		$this->vars['sec'] = hash("sha512",$comnpayWithKey);

        //var_dump($this->vars);
		$this->showPage('end'); //on renvoie vers la page qui contient le formulaire
		return true;
	}



    /*After submiting the plateform payment form, this is where the website will receive the response information from the IPN comnpay gateway and then validate or not the order.*/
	function onPaymentNotification(&$statuses) {
		$feedback = $this->getfeedback();

		$transaction_id = explode('-',$feedback['idTransaction']);
		$order_id = $transaction_id[1];
		$order = $this->getOrder($order_id);
		$this->loadPaymentParams($order);
		if(empty($this->payment_params))
			return false;
		$this->loadOrderData($order);
		if($this->payment_params->debug)
			echo print_r($order);
		if(!$this->validSec($feedback,$this->payment_params->key))  {
			header("Status: 400 Bad Request", false, 400);
			if($this->payment_params->debug)
				echo "Impossible de valider la clé secrète";
			exit();
			return FALSE;
		}
		else {
			if($this->payment_params->debug)
			    echo "Clé Secrète validée";
			if($feedback['result']=="OK") 
				$order_status = $this->payment_params->verified_status;
			else
				$order_status = $this->payment_params->invalid_status;
		}
        $history = new stdClass();
        $history->data = ob_get_clean();
        if($feedback["data"] == "p3f")
            $history->data .= "Paiement en 3 fois";
        else
            $history->data .= "Débit immédiat";
        $this->modifyOrder($order_id, $order_status, $history,true);
		return true;
	}
	
	/*This function return the POST parameters from IPN comNpay gateway */
	function getfeedback() {
		$feedback = $_POST;
		unset($feedback['hikashop_front_end_main']); // generate by hikashop
		unset($feedback['view']); //idem
		return $feedback;
	}
	/*This function valid a secret key passed as a parameter*/
	function validSec($values, $secret_key){
		if (isset($values['sec']) && $values['sec'] != ""){
			$sec = $values['sec'];
			unset($values['sec']);
			return strtoupper(hash("sha512", base64_encode(implode("|",$values)."|".$secret_key))) == strtoupper($sec);
		}
		else{
			return false;
		}
	}
	
	
}

?>